unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls, lFTP, lNet, lNetComponents, bzip2;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    FTP: TLFTPClientComponent;
    Memo1: TMemo;
    PrBar: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FTPConnect(aSocket: TLSocket);
    procedure FTPControl(aSocket: TLSocket);
    procedure FTPError(const msg: string; aSocket: TLSocket);
    procedure FTPReceive(aSocket: TLSocket);
    procedure FTPSent(aSocket: TLSocket; const Bytes: Integer);
  private
    { private declarations }
  public
    { public declarations }
    FFile: TFileStream;
    decoder:Tbzip2_decode_stream;
  end;


var
  Form1: TForm1; 

implementation

{$R *.lfm}
{ TForm1 }


procedure TForm1.Button1Click(Sender: TObject);
var
  Host: string;
  Port: Word = 21;
begin
  Host := 'ftp.freepascal.org';
  Port := 21;
  PrBar.Position:=0;

  Memo1.Append('connecting...');
  FTP.Connect(Host, Port);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if FTP.Connected then
  begin
    Memo1.Append('disconnecting...');
    FTP.Disconnect(true);
    if not FTP.Active then
    begin
      Memo1.Append('sucessfuly disconnected');
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var s, Dir:String;
begin
  Dir := ExtractFilePath(ParamStr(0)); // get current working directory
  FFile := nil; // set "GET" file to nothing for now

  FTP.Binary := True; // set binary mode, others are useless anyhow
  s := '';

  FTP.ChangeDirectory('/pub/fpc/dist/2.4.0/bootstrap');

  Memo1.Append('try getting file');
  s := 'ppc386-win32.zip'; // which file
  if FileExists(Dir + s) then
    DeleteFile(Dir + s);
  FreeAndNil(FFile); // ensure any old file/data is not used
  FFile := TFileStream.Create(Dir + s, fmOpenWrite or fmCreate); // create new file for the incomming one
  FTP.Retrieve(s); // send request for the file over FTP control connnection

end;

procedure TForm1.FTPConnect(aSocket: TLSocket);
var s, UName, Pass, Host :String;
begin
  s := '';
  Memo1.Append('Connected succesfuly');

  Memo1.Append('make auth...');

  UName := 'anonymous'; // username
  Pass := '123@456.com'; // password

  if FTP.Authenticate(UName, Pass) then
  begin // if authentication with server passed
    FTP.GetMessage(s);
    Memo1.Append('Auth successful');
    Memo1.Append(s);
  end else
  begin
    FTP.GetMessage(s);
    Memo1.Append('Auth failed');
    Memo1.Append(s);
  end;
end;

procedure TForm1.FTPControl(aSocket: TLSocket);
var s, s2: string;
    tmpSL:TStringList;
    i:Integer;
begin
  tmpSL:=TStringList.Create;
  if FTP.GetMessage(s) > 0 then // if we got some new message about FTP status, write it
  begin
    Memo1.Append(s);
    tmpSL.Append(s);
    for i:=0 to tmpSL.Count-1 do
    begin
      //150 - Information about file
      if Pos('150', tmpSL.Strings[i])>0 then
      begin
        //Extract filesize and set PB.Max
        s2:=tmpSL.Strings[i];
        delete(s2 , 1,  pos('(', s2));
        s2:=copy(s2, 1, pos(' ', s2)-1);
        PrBar.Max:=StrToInt(s2);
      end;

//226 - Transfer successful
//      if Pos('226', tmpSL.Strings[i])>0 then
//        Button2.Click; // close connection
    end;
  end;
  tmpSL.Free;
end;

procedure TForm1.FTPError(const msg: string; aSocket: TLSocket);
begin
  Memo1.Append('Error: '+msg);
end;

procedure TForm1.FTPReceive(aSocket: TLSocket);
const
  BUFFER_SIZE = 65535; // usual maximal recv. size defined by OS, no problem if it's more or less really
var
  n: Integer;
  Buf: array[0..BUFFER_SIZE-1] of Byte;
begin
  if FTP.CurrentStatus = fsRetr then
  begin // if we're in getting mode
    n := FTP.GetData(Buf, BUFFER_SIZE); // get data, n is set to the amount
    if Assigned(FFile) then
        FFile.Write(Buf, n); // otherwise, write the data to file
    //set PB.Position
    PrBar.Position:=PrBar.Position+n;
  end else
    Memo1.Append(FTP.GetDataMessage); // if we got data and we weren't in getting mode, write it on the screen as FTP info
end;

procedure TForm1.FTPSent(aSocket: TLSocket; const Bytes: Integer);
begin
  Memo1.Append('sending');
end;

end.

